> For the complete documentation index, see [llms.txt](https://docs.replicacyber.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.replicacyber.com/developer-guide/butler-api-reference/storage.md).

# Storage

Enclave Storage Actions

## Get permitted Enclave Storage

> Gets a list of Butler Enclave Storage user is permitted to access

```json
{"openapi":"3.0.0","info":{"title":"Replica Butler","version":"4.5.0"},"tags":[{"name":"Storage","description":"Enclave Storage Actions"}],"servers":[{"url":"/butler/api/","description":"Replica Butler"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ReplicaMessageSuccess":{"type":"object","properties":{"statusCode":{"type":"integer"},"success":{"type":"boolean"},"message":{"type":"string"},"event":{"type":"string","$ref":"#/components/schemas/ReplicaEvent"},"items":{"type":"array"}}},"ReplicaEvent":{"type":"string","enum":["GET","POST","PUT","DELETE","ERROR"]},"EnclaveStorageInfo":{"type":"object","required":["id","name","assignee"],"properties":{"id":{"type":"string","description":"The Id"},"name":{"type":"string","description":"The name"},"assignee":{"allOf":[{"$ref":"#/components/schemas/Assignee"},{"type":"object","properties":{"displayName":{"type":"string"}}}]}}},"Assignee":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","$ref":"#/components/schemas/AssigneeType"}}},"AssigneeType":{"type":"string","enum":["user","group","profile"]},"ReplicaMessageFailure":{"type":"object","properties":{"statusCode":{"type":"integer"},"success":{"type":"boolean"},"message":{"type":"string"},"event":{"type":"string","$ref":"#/components/schemas/ReplicaEvent"},"items":{"type":"array"}}}}},"paths":{"/v1/resources":{"get":{"summary":"Get permitted Enclave Storage","description":"Gets a list of Butler Enclave Storage user is permitted to access","tags":["Storage"],"parameters":[{"name":"ids","in":"query","required":false,"description":"Optional comma separated Ids","schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/ReplicaMessageSuccess"},{"type":"object","properties":{"message":{},"items":{"type":"array","$ref":"#/components/schemas/EnclaveStorageInfo"}}}]}}}},"500":{"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/ReplicaMessageFailure"},{"type":"object","properties":{"message":{}}}]}}}}}}}}}
```

## Create new Enclave Storage

> Create and assign new Enclave Storage

```json
{"openapi":"3.0.0","info":{"title":"Replica Butler","version":"4.5.0"},"tags":[{"name":"Storage","description":"Enclave Storage Actions"}],"servers":[{"url":"/butler/api/","description":"Replica Butler"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"StorageCreateRequest":{"type":"object","required":["displayName","assignee"],"properties":{"displayName":{"type":"string","description":"The Enclave Storage name"},"assignee":{"type":"object","$ref":"#/components/schemas/Assignee"},"storageType":{"type":"string","$ref":"#/components/schemas/StorageType"}}},"Assignee":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","$ref":"#/components/schemas/AssigneeType"}}},"AssigneeType":{"type":"string","enum":["user","group","profile"]},"StorageType":{"type":"string","enum":["Isolated","Synchronous"]},"ReplicaMessageSuccess":{"type":"object","properties":{"statusCode":{"type":"integer"},"success":{"type":"boolean"},"message":{"type":"string"},"event":{"type":"string","$ref":"#/components/schemas/ReplicaEvent"},"items":{"type":"array"}}},"ReplicaEvent":{"type":"string","enum":["GET","POST","PUT","DELETE","ERROR"]},"ReplicaMessageFailure":{"type":"object","properties":{"statusCode":{"type":"integer"},"success":{"type":"boolean"},"message":{"type":"string"},"event":{"type":"string","$ref":"#/components/schemas/ReplicaEvent"},"items":{"type":"array"}}}}},"paths":{"/v1/resources":{"post":{"summary":"Create new Enclave Storage","description":"Create and assign new Enclave Storage","tags":["Storage"],"requestBody":{"description":"Enclave Storage create request body","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/StorageCreateRequest"}}}},"responses":{"200":{"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/ReplicaMessageSuccess"},{"type":"object","properties":{"message":{}}}]}}}},"500":{"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/ReplicaMessageFailure"},{"type":"object","properties":{"message":{}}}]}}}}}}}}}
```

## DELETE /v1/resources/{id}

> Delete Enclave Storage by Id

```json
{"openapi":"3.0.0","info":{"title":"Replica Butler","version":"4.5.0"},"tags":[{"name":"Storage","description":"Enclave Storage Actions"}],"servers":[{"url":"/butler/api/","description":"Replica Butler"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ReplicaMessageSuccess":{"type":"object","properties":{"statusCode":{"type":"integer"},"success":{"type":"boolean"},"message":{"type":"string"},"event":{"type":"string","$ref":"#/components/schemas/ReplicaEvent"},"items":{"type":"array"}}},"ReplicaEvent":{"type":"string","enum":["GET","POST","PUT","DELETE","ERROR"]},"ReplicaMessageFailure":{"type":"object","properties":{"statusCode":{"type":"integer"},"success":{"type":"boolean"},"message":{"type":"string"},"event":{"type":"string","$ref":"#/components/schemas/ReplicaEvent"},"items":{"type":"array"}}}}},"paths":{"/v1/resources/{id}":{"delete":{"summary":"Delete Enclave Storage by Id","tags":["Storage"],"parameters":[{"name":"id","in":"path","required":true,"description":"The Enclave Storage Id","schema":{"type":"string"}}],"responses":{"200":{"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/ReplicaMessageSuccess"},{"type":"object","properties":{"message":{},"items":{"type":"array"}}}]}}}},"500":{"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/ReplicaMessageFailure"},{"type":"object","properties":{"message":{}}}]}}}}}}}}}
```

## Assign Enclave Storage

> Assign Enclave Storage

```json
{"openapi":"3.0.0","info":{"title":"Replica Butler","version":"4.5.0"},"tags":[{"name":"Storage","description":"Enclave Storage Actions"}],"servers":[{"url":"/butler/api/","description":"Replica Butler"}],"security":[{"bearerAuth":[]}],"components":{"securitySchemes":{"bearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"AssignmentRequest":{"type":"object","required":["id","assignee"],"properties":{"id":{"type":"string","description":"The Id"},"assignee":{"type":"object","$ref":"#/components/schemas/Assignee"}}},"Assignee":{"type":"object","properties":{"id":{"type":"string"},"type":{"type":"string","$ref":"#/components/schemas/AssigneeType"}}},"AssigneeType":{"type":"string","enum":["user","group","profile"]},"ReplicaMessageSuccess":{"type":"object","properties":{"statusCode":{"type":"integer"},"success":{"type":"boolean"},"message":{"type":"string"},"event":{"type":"string","$ref":"#/components/schemas/ReplicaEvent"},"items":{"type":"array"}}},"ReplicaEvent":{"type":"string","enum":["GET","POST","PUT","DELETE","ERROR"]},"ReplicaMessageFailure":{"type":"object","properties":{"statusCode":{"type":"integer"},"success":{"type":"boolean"},"message":{"type":"string"},"event":{"type":"string","$ref":"#/components/schemas/ReplicaEvent"},"items":{"type":"array"}}}}},"paths":{"/v1/resources/assignments/{id}":{"post":{"summary":"Assign Enclave Storage","description":"Assign Enclave Storage","tags":["Storage"],"requestBody":{"description":"Enclave Storage assignment request body","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AssignmentRequest"}}}},"responses":{"200":{"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/ReplicaMessageSuccess"},{"type":"object","properties":{"message":{}}}]}}}},"500":{"content":{"application/json":{"schema":{"allOf":[{"$ref":"#/components/schemas/ReplicaMessageFailure"},{"type":"object","properties":{"message":{}}}]}}}}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.replicacyber.com/developer-guide/butler-api-reference/storage.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
